<?php
	// html-table-sa-edit5-DBIO - php & [Ajax] DB I/O routines...
		
		//include_once '../Includes/db.inc.php';
		//include_once __DIR__ . '/../Includes/db.inc.php';
		//include_once __DIR__ . '/db.inc.php';
		include_once 'db.inc.php';

function readBookingItemList($bookingNo) {
	// Read list of items for $bookingNo.
	if ($bookingNo <= '' ) {
		return json_encode('No Booking Number:' . $bookingNo . ':');
	}
	try {
		global $pdo;
		// NB: SQL SELECT * v/s COLUMNS - to be checked in php land ???
		// Formatted 'ready' for field.option(set)
		$sql = "SELECT ID, BookingNo, BookingLineNo, BillingItemNo, BillingDesc, LinkedLineNo, BillingCharge " 
 			  . "FROM BookingItems "
 			  . "WHERE BookingNo = :BookingNo";
 			
 			//echo '<script type="text/javascript">alert("' . "Pre-Execute" . $sql . '");</script>';
 						
 		$query = $pdo->prepare($sql);
 		$query->bindValue(':BookingNo', $bookingNo);
		$qResult = $query->execute();
		$qRows = $query->fetchAll(PDO::FETCH_ASSOC);
		
	}		     
	catch (PDOException $e)
	{	
	//$query->debugDumpParams();
		return json_encode(array('Query:' => $query, 'Error:' => $e->getMessage()));

	}
	return json_encode($qRows);
}


function readBillingItemList() {
	// Read all our available billing Items (EXCLUDING surcharge items))
	try {
		global $pdo;
		// NB: SQL SELECT * v/s COLUMNS - to be checked in php land ???
		// Formatted 'ready' for field.option(set)
		$sql = "SELECT CONCAT(BillingDesc, '(', BillingItemNo, ')') as label, BillingItemNo as value" 
 			  . "	FROM BillingItems "
 			  . " WHERE LinkedItemNo >= 0 "
 			  . " ORDER BY BillingDesc ASC ";
 			
 			//echo '<script type="text/javascript">alert("' . "Pre-Execute" . $sql . '");</script>';
 						
 		$query = $pdo->prepare($sql);
		$qResult = $query->execute();
		$qRows = $query->fetchAll(PDO::FETCH_ASSOC);
		
	}		     
	catch (PDOException $e)
	{	
	//$query->debugDumpParams();
		return json_encode(array('Query:' => $query, 'Error:' => $e->getMessage()));

	}
	return json_encode($qRows);
}

function readBillingItem($billingItemNo, $linkedLineNo) {
	// Read 1 x BillingItem, optionally returning the LinkedLine associated with it.
	// (should be a better way of passing the linked line number around ???)
	if ($billingItemNo <= '' ) {
		return json_encode(array('Query:' => 'Item No:' . $billingItemNo, 'Error:' => 'No Item No'));
	}
	try {
		global $pdo;
		// NB: SQL SELECT * v/s COLUMNS - to be checked in php land ???
		// Formatted 'ready' for field.option(set)
		$sql = "SELECT BillingItemNo, BillingDesc, BillingCharge, LinkedItemNo, :LinkedLineNo as LinkedLineNo " 
 			  . "FROM BillingItems "
 			  . "WHERE BillingItemNo = :BillingItemNo";
 			
 			//echo '<script type="text/javascript">alert("' . "Pre-Execute" . $sql . '");</script>';
 						
 		$query = $pdo->prepare($sql);
 		$query->bindValue(':BillingItemNo', $billingItemNo);
 		$query->bindValue(':LinkedLineNo', $linkedLineNo);
		$qResult = $query->execute();
		$qRow = $query->fetch(PDO::FETCH_ASSOC);
		
	   //$qRow = $query->fetch();
		// Should we return an 'empty row' if no record found, so that datavars are all 'empty' & not 'undefined' ???
	}		     
	catch (PDOException $e)
	{	
	//$query->debugDumpParams();
		return json_encode(array('Query:' => $query, 'Error:' => $e->getMessage()));

	}
	return json_encode($qRow);
}

/* *******************************************************************************************
   ************** disabled at the moment, re PHP 5 v/s PHP 7 *********************************
   *******************************************************************************************
   *** Merge back into here once PHP7.x is established.
   
   see 'html-table-sa-edit5-DBIO-ajax.php' ...
    		
	// end html-table-sa-edit5-DBIO.php include only section:-
	if (__FILE__ != $_SERVER['SCRIPT_FILENAME'])  return 0;	// Called as include, return without error
	

// *** Ajax Call handling for db functions required at javascript runtime ***		
		
	// Prevent caching.
	header('Cache-Control: no-cache, must-revalidate');
	header('Expires: Mon, 01 Jan 1900 00:00:00 GMT');

	// The JSON standard MIME header.
	header('Content-type: application/json');

	// Parse call params & proceess ...

	$action=$_GET['action'];
	//echo "Action:" . $action;
	switch ($action) {
		// Depending on requested DB I/O function ...

   default:
		// return some sort of error flag...
		echo "invalid action tag[".$action."] error";
		break;
	}
	*/
?>

